;**************************************************
; RingZer0 present:
;
; Another IPC method
;
; Written By GEnius
;**************************************************


;***********************************************************
; Il codice presente  riportato solo per scopo didattico
; non penso sia molto utile, almeno in questa versione!
; Limitazioni dei servizi del vxd:
; - solo un blocco all volta pu essere reso pubblico
; -  possibile rendere pubblici solo blocchi di grandezza
; multipla di 4kb (Se il vostro blocco da rendere 
; di 3kb il servizio funzioner comunque ma verr reso pubblico
; anche il kb successivo al blocco! Con conseguente possibilit
; da parte degli altri processi di scrivere in quel kb che non 
; dovrebbe riguardare loro)
; - nessun controllo degli errori!
;
;Breve descrizione dei servizi per il client messi a 
;disposizione da RZvxd.vxd:
;
; IPC_GET_SHARE_BLOCK
; servizio usato per acquisire l'accesso ad un blocco di
; memoria reso pubblico dal server. Parametri:
;
; OutputBuffer  un buffer 6 byte che riceve la seguente struttura:
; DD IndirizzoBuffer -  l'indirizzo lineare del blocco pubblico
; se  0 il server non ha ancora reso pubbblico il blocco
; Dw Selector -  un selettore al blocco pubblico
; se  0 il server non ha ancora reso pubblico il blocco
;
; IPC_BLOCK_PRESENT
; servizio usato per non far capire se il blocco  ancora presente
; o il Server lo ha rilasciato. Parametri: 
; OutputBuffer  un buffer di 4 byte che riceve 1 se il blocco
;  ancora presente 0 se non lo  pi

.486
locals
jumps

UNICODE = 0
.model flat,STDCALL


extrn	GetProcAddress		: PROC
extrn   GetCurrentProcess	: PROC
extrn   DeviceIoControl		: PROC

include W32.inc           

L                       EQU <LARGE>
IPC_SHARE_BLOCK         EQU 1
IPC_LEAVE_BLOCK         EQU 2
IPC_GET_SHARE_BLOCK     EQU 3
IPC_BLOCK_PRESENT       EQU 4

.data
prova           db 35 dup (0h) ;ci copio il primo messaggio
hInst           dd 0
client          db 'Client:',0

ControlCode     dd 1
vxdReturn       dd 2 dup(0) ;buffer per ricevere dati dal vxd

IndLinear       dd 0 ;indirizzo lineare del blocco
Selector        dw 0 ; Selettore al blocco

Testo           db 'Non esiste nessun blocco globale al momento',0

Vxd_Handle      dd 0 ;Handle del Vxd
VxDName         db '\\.\RZvxd.vxd',0 
VxDErrorTxT     db 'Cannot load RingZ.vxd :(',0
ErrHeader       db 'Errore',0

.code


start:

        push    L 0
        call    GetModuleHandle         ; get hmod 
        mov     [hInst], eax            ; hInstance is same as HMODULE

        call    OpenVxD                 ;Open the Baby!
        cmp     eax,-1
        jne     NoError
        call    VxDError		;minghia!
        jmp exit

NoError:
        mov ControlCode, IPC_GET_SHARE_BLOCK
	Call VxDUse ;voglio l'indirizzo del blocco pubblico
        cmp word ptr [vxdReturn],0 
        jz mess
        mov ax, word ptr [vxdReturn+4]
        mov [Selector], ax ;Setto la variabile Selector con ilk selettore al blocco
        mov eax, [vxdReturn]
        mov [IndLinear], eax ;ora memorizzo l'indirizzo lineare del blocco
        push es ;salviamo ES attuale
        mov es, [Selector]
        mov ebx, es:0 
        mov ecx, 0ffffh 
        mov eax,0
        mov edi,ebx
        repnz scasb ;vedo quando  lunga la prima stringa nel blocco
        sub edi,ebx
        mov ecx,edi
        mov esi,ebx
        mov edi, offset prova
        push ds
        push es
        pop ds
        pop es
        rep movsb ; copio la prima stringa nel buffer prova
        push es
        pop ds
        pop es
        Call MessageBox, 0, offset prova, offset client,0 ;visualizzo il buffer prova
        mov ControlCode, IPC_BLOCK_PRESENT
        Call VxDUse       ;controllo che il blocco esista ancora!
        cmp word ptr [vxdReturn],0 
        jz chiudi 
        mov eax, [IndLinear] ;ora usiamo l'indirizzo lineare invece che il selettore!
        add eax, [eax+4]
        Call MessageBox, 0, eax, offset client,0 ;visualizzo la seconda stringa nel blocco
                                                ;semplicemente usando un indirizzo lineare
chiudi:
        Call CloseVxD

exit:
        push    LARGE-1
        call    ExitProcess  ;fine programma!           

mess:
        Call MessageBox, 0, offset Testo, offset client,0
        jmp exit
;-------------------------------------------------------------------------------------------
; Procedure per la comunicazione con il VXD
; Semplici ed intuitive!
;-------------------------------------------------------------------------------------------

OpenVxD PROC ;Apre il vxd
        push    0
        push    L FILE_FLAG_DELETE_ON_CLOSE
        push    0
        push    0
        push    0
        push    0
        push    offset VxDName
        call    CreateFileA ;Uaoo un semplice Createfile!!
        mov     Vxd_Handle,eax 
        cmp     eax,-1
        je      VxDError
        ret
OpenVxD ENDP

CloseVxD PROC ; Chiude il Vxd....Bye Bye Baby :D
         push    [Vxd_Handle]
         call    CloseHandle
         mov     eax,1
         ret                     ;All Ok!!
CloseVxD ENDP

VxDError PROC ; Visualizza un dialogbox con il messaggio di errore
         push    L 0
         call    MessageBeep
         push    L MB_ICONEXCLAMATION
         push    offset ErrHeader
         push    offset VxDErrorTxT
         push    0
         call    MessageBoxA
         ret
VxDError ENDP

VxDUse  PROC ; Questa  la proc + importante chiama un servizio del vxd
; il servizio attuale da chiamare si trova nella variabile ControlCode
	push    L NULL
        push    0                       ;lp to bytes returned
        push    0                       ;size of output buffer
        push    offset vxdReturn        ;lp to output data
        push    0                       ;size of input buffer
        push    0                       ;lp to input data
        push    [ControlCode]           ;Control code 
        push    [Vxd_Handle]
        call    DeviceIoControl
        ret
VxDUse  ENDP

end start
