.586
.MODEL FLAT, STDCALL
OPTION CASEMAP :NONE   

INCLUDE \USER\W32ASM\MASM\INCLUDE\K32UNDOC.INC
INCLUDE \USER\W32ASM\MASM\INCLUDE\WINDOWS.INC
INCLUDE \USER\W32ASM\MASM\INCLUDE\KERNEL32.INC
INCLUDE \USER\W32ASM\MASM\INCLUDE\USER32.INC
INCLUDE \USER\W32ASM\MASM\INCLUDE\GDI32.INC
INCLUDE \USER\W32ASM\MASM\INCLUDE\COMCTL32.INC
INCLUDE \USER\W32ASM\MASM\INCLUDE\COMDLG32.INC

INCLUDELIB \USER\W32ASM\MASM\LIB\KERNEL32.LIB
INCLUDELIB \USER\W32ASM\MASM\LIB\USER32.LIB
INCLUDELIB \USER\W32ASM\MASM\LIB\GDI32.LIB
INCLUDELIB \USER\W32ASM\MASM\LIB\COMCTL32.LIB
INCLUDELIB \USER\W32ASM\MASM\LIB\COMDLG32.LIB      
INCLUDELIB SPYDLL.LIB      
      
return MACRO arg
  mov eax,arg
 ret
ENDM

wsprintfA      PROTO C :DWORD, :VARARG
wsprintf       TEXTEQU <wsprintfA>
WinMain        PROTO :DWORD,:DWORD,:DWORD,:SDWORD
EnableFBtn     PROTO :DWORD
EnableRBtn     PROTO :DWORD
ErrorMessage   PROTO :DWORD
ShowHeader     PROTO :DWORD
ShowResources  PROTO :DWORD,:DWORD,:DWORD
ShowImports    PROTO :DWORD,:DWORD,:DWORD
NotImplemented PROTO
ListOut        PROTO :DWORD,:DWORD,:DWORD
_strcpy        PROTO :DWORD,:DWORD
_strlen        PROTO :DWORD

DISPACTH_ENTRY STRUCT 
 cbActions         WORD  ? 
 dwMsgBase         DWORD ?
 tActionTable      DWORD ?
DISPACTH_ENTRY ENDS

.CONST

cMMFromPageFile EQU -1
AppendSize DD StopAppend-StartAppend
WM_SPYSERVICE = WM_USER+1
SRV_HANDSHAKE = 00000001 
SRV_SHOWRES   = 00000002 
SRV_SHOWIT    = 00000003

INCLUDE PESPY.INC      

.DATA

szClassName    DB "PESPYCLASS",0
szSrvClassName DB "PESPYSERVER",0
szProgramName  DB "RingZ3r0 - PESpy v.0.05",0
szMMF          DB "CARONTE",0
szSyncEvent    DB "SpySyncEvent",0

szNull        DB 0
szNTHeaders   DB "[NT HEADERS  ]",0
szPEHeader    DB "PE Headers start at :0x%08lX",0
szNumSecs     DB "Num of Sections",09,": 0x%08lX",09,"Size Optional Hdr",09,": 0x%08lX",0
szCharats     DB "Charateristics ",09,": 0x%08lX",09,"Magic            ",09,": 0x%08lX",0
szImgbase     DB "Imagebase      ",09,": 0x%08lX",09,"Entrypoint RVA   ",09,": 0x%08lX",0
szImgSize     DB "Size of Image  ",09,": 0x%08lX",09,"Size of Headers  ",09,": 0x%08lX",0
szImgAlign    DB "Section Align  ",09,": 0x%08lX",09,"File Alignment   ",09,": 0x%08lX",0
szBaseCode    DB "Base of Code   ",09,": 0x%08lX",09,"Base of Data     ",09,": 0x%08lX",0
szSizeCode    DB "Size of Code   ",09,": 0x%08lX",09,"Checksum         ",09,": 0x%08lX",0
szDataDir     DB "[  DATA DIRECTORY  ]",0
szDataHdr     DB "Dir Entry     ",09,"RVA",09,09,"Size",0
szDExports    DB "Exports       ",09,"0x%08lX",09,"0x%08lX",0
szDImports    DB "Imports       ",09,"0x%08lX",09,"0x%08lX",0
szDResource   DB "Resource      ",09,"0x%08lX",09,"0x%08lX",0
szDRelocs     DB "Relocations   ",09,"0x%08lX",09,"0x%08lX",0
szDTLS        DB "TLS           ",09,"0x%08lX",09,"0x%08lX",0
szDIAT        DB "Adresses Table",09,"0x%08lX",09,"0x%08lX",0
szDBoundIT    DB "Bound Imports ",09,"0x%08lX",09,"0x%08lX",0
szDDelayIT    DB "Delay Imports ",09,"0x%08lX",09,"0x%08lX",0
szSections    DB "[  SECTIONS TABLE  ]",0
szSectHdr     DB "Name           ",09,"RVA            VSize  "
              DB "        RawPtr       RawSize     Flags",0
szSectDesc    DB "%.8s           ",09,"%08lX   %08lX   %08lX   %08lX   %08lX",0

szOfnFilter      DB "Executable Files",0,"*.exe",0,"All Files",0,"*.*",0,0
szNotImplemented DB "Not yet implemented",0
szGeneralError   DB  "Unexpected application error : bye bye...", 0
szGenErrMsg      DB  "An error has occured: unable to complete operation",0 
szAboutMsg       DB  09,09,"PESpy v.0.05             ",0Ah,0Dh,0Ah,0Dh
                 DB  "          by Kill3xx for RingZ3r0",0Ah,0Dh,0

szProgmam           DB "Progman",0                 
szKernel32	    DB "Kernel32.dll",0
szLoadLibraryA	    DB "LoadLibraryA",0
szGetProcAddress    DB "GetProcAddress",0
szExitProcess       DB "ExitProcess",0


DispatchTable  DISPACTH_ENTRY <2,IDM_MAIN_BASE+1,offset tAct_Main>
               DISPACTH_ENTRY <4,IDM_FPEACT_BASE+1,offset tAct_PEFile>
               DISPACTH_ENTRY <5,IDM_RPEACT_BASE+1,offset tAct_PERun>
DispatchTableL equ ($-DispatchTable)/sizeof DISPACTH_ENTRY

ALIGN DWORD
tAct_Main   dd     offset doBrowse
            dd     offset doAbout
tAct_PEFile dd     offset doFLoad
            dd     offset doFUnLoad
            dd     offset doFResDump
            dd     offset doFITDump
tAct_PERun  dd     offset doRLoad
            dd     offset doRUnLoad
            dd     offset doRResDump
            dd     offset doRITDump
            dd     offset doRIATScan

.DATA?
szDivider        DB     200 dup (?)
szDividerl       EQU    ($-szDivider)-2
szFilePath       DB     MAX_PATH dup (?)
szStrBuffer      DB     260 dup (?)
szStrBufferl     EQU    ($-szStrBuffer)-1
szCommandLine    TEXTEQU <szStrBuffer>
szCurrentDir     DB     MAX_PATH dup (?)
szSectName       DB     9   dup (?)
hInstance        HANDLE ?
hMain            HWND   ?
hFile            HANDLE ?
hFileMap         HANDLE ?
ImageBase        DD     ?
lpPEHeader       DD     ?
dwFileSize       DD     ?
hFLoadBtn        HWND   ?
hFUnLoadBtn      HWND   ?
hFResTBtn        HWND   ?
hFImportBtn      HWND   ?
hRLoadBtn        HWND   ?
hRUnLoadBtn      HWND   ?
hRResTBtn        HWND   ?
hRImportBtn      HWND   ?
hRIATBtn         HWND   ?
hTargetEdt       HWND   ?
hList            HWND   ?
hServer          HWND   ?
hGateView        HANDLE ?
OFN              OPENFILENAME        <?>
sif              STARTUPINFO         <?>
sa               SECURITY_ATTRIBUTES <?>
pif              PROCESS_INFORMATION <?>
ProcessID        DD     ?
ThreadID         DD     ?
SyncObjects      HANDLE  2 dup (?)
cbBytes          DD     ?
 
.CODE
        ASSUME  fs:nothing
start:
        push     offset xTermHandler 
        call     SetUnhandledExceptionFilter        
        invoke   GetModuleHandle,NULL
        mov      [hInstance],eax
        invoke   WinMain,[hInstance],NULL,NULL,SW_SHOWDEFAULT
        invoke   ExitProcess,eax
        invoke   InitCommonControls

xTermHandler:
        invoke   MessageBeep,-1
        invoke   MessageBox,NULL,ADDR szGeneralError,ADDR szProgramName,MB_ICONHAND
        invoke   ExitProcess,-1

     
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:SDWORD
        
         LOCAL wc   :WNDCLASSEX
         LOCAL msg  :MSG
         LOCAL hWnd :HANDLE

         mov   [wc].cbSize, sizeof WNDCLASSEX
         mov   [wc].style, CS_HREDRAW + CS_VREDRAW
         mov   [wc].lpfnWndProc,offset WndProc
         mov   [wc].cbClsExtra, 0
         mov   [wc].cbWndExtra, DLGWINDOWEXTRA
         mov   [wc].hInstance,eax
         invoke  LoadIcon,eax,IDI_ICON1
         mov   [wc].hIcon,eax
         mov   [wc].hIconSm,eax
         invoke  LoadCursor,NULL,IDC_ARROW
         mov   [wc].hCursor,eax
         mov   [wc].hbrBackground,COLOR_BACKGROUND
         mov   [wc].lpszMenuName,NULL
         mov   [wc].lpszClassName,offset  szClassName
        
         invoke  RegisterClassEx,ADDR wc

         invoke  CreateDialogParam,[hInst],ADDR szClassName,0,NULL,0     
         mov       [hWnd],eax

         invoke GetDlgItem,[hWnd],IDC_EDITPATH
         mov    [hTargetEdt],eax
         invoke GetDlgItem,[hWnd],IDC_FLoad
         mov    [hFLoadBtn],eax
         invoke GetDlgItem,[hWnd],IDC_FUnLoad
         mov    [hFUnLoadBtn],eax
         invoke GetDlgItem,[hWnd],IDC_FResTree
         mov    [hFResTBtn],eax
         invoke GetDlgItem,[hWnd],IDC_FImport
         mov    [hFImportBtn],eax
         invoke GetDlgItem,[hWnd],IDC_OUTLIST
         mov    [hList],eax
         invoke GetDlgItem,[hWnd],IDC_RLoad
         mov    [hRLoadBtn],eax
         invoke GetDlgItem,[hWnd],IDC_RUnLoad
         mov    [hRUnLoadBtn],eax
         invoke GetDlgItem,[hWnd],IDC_RResTree
         mov    [hRResTBtn],eax
         invoke GetDlgItem,[hWnd],IDC_RImport
         mov    [hRImportBtn],eax
         invoke GetDlgItem,[hWnd],IDC_RIATScan
         mov    [hRIATBtn],eax         

         invoke RtlFillMemory,ADDR szDivider,szDividerl,2Dh

         xor    eax,eax
         invoke EnableFBtn,eax
         invoke EnableRBtn,eax
         invoke EnableWindow,[hRLoadBtn],eax
 
@@MsgLoop: 
         invoke GetMessage,ADDR msg,NULL,0,0
         or       eax,eax
         je     @@EndLoop
         invoke IsDialogMessage,[hWnd],ADDR msg
         cmp        eax,TRUE
         jz       @@MsgLoop
         invoke TranslateMessage,ADDR msg
         invoke DispatchMessage,ADDR msg
         jmp        @@MsgLoop
@@EndLoop:
         return msg.wParam
        ret 
WinMain ENDP


WndProc PROC USES ebx edi esi, hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
                  
         cmp    [uMsg],WM_COMMAND
         jz     OnWMCommand
         cmp    [uMsg],WM_DESTROY
         jz     OnWMDestroy
         invoke DefWindowProc,[hWnd],[uMsg],[wParam],[lParam]
         jmp    @quit
         jmp    @quit
OnWMDestroy:
         invoke  SendMessage,[hFUnLoadBtn],BM_CLICK,NULL,NULL
         invoke PostQuitMessage,NULL
         xor    eax,eax
@quit:
        ret

OnWMCommand:
         mov   ebx,[wParam]
         and   ebx,0FFFFh
         mov   ecx,DispatchTableL
         mov   edi,offset DispatchTable
         ASSUME edi : PTR DISPACTH_ENTRY
@@do_cmd:         
         movzx edx,word ptr [edi].cbActions
         mov   eax,[edi].dwMsgBase
         add   edx,eax
         cmp   ebx,eax
         jl    @@next
         cmp   ebx,edx
         ja    @@next
         jmp   @@dispatch
@@next:         
         add   edi,sizeof DISPACTH_ENTRY
         dec   ecx
         jnz   @@do_cmd
         jmp   @quit
@@dispatch:
         sub   ebx,eax
         mov   esi,[edi].tActionTable
         shl   ebx,2
         push  [lParam]
         push  [wParam]
         push  [uMsg]
         push  [hWnd]
         push  offset @quit
         jmp   DWORD PTR [esi+ebx]
        ret 
WndProc ENDP

doFLoad PROC USES ebx edi esi, hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
         lea    eax,szFilePath
         cmp    byte ptr [eax],NULL
         jz     @@lquit
         invoke CreateFileA, \                          
          eax, \
          GENERIC_READ, \
          FILE_SHARE_READ, \
          NULL, \
          OPEN_EXISTING, \
          FILE_ATTRIBUTE_NORMAL + \
          FILE_FLAG_SEQUENTIAL_SCAN, \
          0
         .IF eax==INVALID_HANDLE_VALUE 
            invoke  ErrorMessage,ERROR_COULD_NOT_OPEN_FILE
            jmp     @@lquit
         .ENDIF 
         mov     [hFile],eax
         invoke   GetFileSize,eax,NULL            
         .IF eax==INVALID_HANDLE_VALUE 
            invoke  ErrorMessage,ERROR_INVALID_FILESIZE
            jmp     @@lquit
         .ENDIF 
         mov     [dwFileSize],eax
         invoke  CreateFileMapping,[hFile],NULL,PAGE_READONLY,0,0,NULL
         .IF eax==0
            invoke  ErrorMessage,ERROR_COULD_NOT_CREATE_FILEMAP
            jmp     @@lquit
         .ENDIF 
         mov     [hFileMap],eax
         invoke  MapViewOfFile,eax,FILE_MAP_READ,0,0,0    
         .IF eax==0
            invoke  ErrorMessage,ERROR_COULD_NOT_MAPVIEW
            jmp     @@lquit
         .ENDIF 
         mov     [ImageBase],eax
         mov     edi,eax
         call    GetNtHeader
         .IF eax==INVALID_HANDLE_VALUE 
            invoke  ErrorMessage,ERROR_INVALID_PEFILE
            jmp     @@lquit
         .ENDIF 
         mov     [lpPEHeader],edi
         ASSUME  edi : PTR IMAGE_NT_HEADERS
         mov     eax,[edi].OptionalHeader.AddressOfEntryPoint
         add     eax,[edi].OptionalHeader.ImageBase              ; <- cambiare
         mov     [EntryPoint],eax
         invoke  SendMessage,[hList],LB_RESETCONTENT,0,0
         invoke  SendMessage,[hList],LB_ADDSTRING,0,ADDR szNTHeaders
         invoke  SendMessage,[hList],LB_ADDSTRING,0,ADDR szNull 
         ASSUME  edi : PTR IMAGE_NT_HEADERS
         movzx   eax,word ptr [edi].FileHeader.NumberOfSections
         movzx   edx,word ptr [edi].FileHeader.SizeOfOptionalHeader
         invoke  ListOut,ADDR szNumSecs,eax,edx
         movzx   eax,word ptr [edi].FileHeader.Characteristics
         movzx   edx,word ptr [edi].OptionalHeader.Magic
         invoke  ListOut,ADDR szCharats,eax,edx 
         invoke  ListOut,\
          ADDR szImgbase, \
          [edi].OptionalHeader.ImageBase, \
          [edi].OptionalHeader.AddressOfEntryPoint
         invoke  ListOut,\
          ADDR szImgAlign, \
          [edi].OptionalHeader.SectionAlignment, \
          [edi].OptionalHeader.FileAlignment
         invoke  ListOut,\
          ADDR szImgSize, \
         [edi].OptionalHeader.SizeOfImage, \
          [edi].OptionalHeader.SizeOfHeaders 
          invoke  ListOut,\
          ADDR szBaseCode, \
          [edi].OptionalHeader.BaseOfCode, \
          [edi].OptionalHeader.BaseOfData
         invoke  ListOut,\
          ADDR szSizeCode, \
          [edi].OptionalHeader.SizeOfCode, \
          [edi].OptionalHeader.CheckSum
         invoke  SendMessage,[hList],LB_ADDSTRING,0,ADDR szNull 
         invoke  SendMessage,[hList],LB_ADDSTRING,0,ADDR szDataDir
         invoke  SendMessage,[hList],LB_ADDSTRING,0,ADDR szNull 
         invoke  SendMessage,[hList],LB_ADDSTRING,0,ADDR szDataHdr
         invoke  SendMessage,[hList],LB_ADDSTRING,0,ADDR szDivider
         invoke  ListOut,\
          ADDR  szDExports, \
          [edi].OptionalHeader.DataDirectory(IMAGE_DIR_EXPORT).VirtualAddress, \
          [edi].OptionalHeader.DataDirectory(IMAGE_DIR_EXPORT).iSize
         invoke  ListOut,\
          ADDR  szDImports, \
          [edi].OptionalHeader.DataDirectory(IMAGE_DIR_IMPORT).VirtualAddress, \
           [edi].OptionalHeader.DataDirectory(IMAGE_DIR_IMPORT).iSize 
         invoke  ListOut,\
          ADDR  szDResource, \
           [edi].OptionalHeader.DataDirectory(IMAGE_DIR_RESOURCE).VirtualAddress, \
          [edi].OptionalHeader.DataDirectory(IMAGE_DIR_RESOURCE).iSize  
         invoke  ListOut,\
          ADDR  szDRelocs, \
          [edi].OptionalHeader.DataDirectory(IMAGE_DIR_RELOC).VirtualAddress, \
           [edi].OptionalHeader.DataDirectory(IMAGE_DIR_RELOC).iSize  
         invoke  ListOut,\
          ADDR  szDTLS, \
           [edi].OptionalHeader.DataDirectory(IMAGE_DIR_TLS).VirtualAddress, \
          [edi].OptionalHeader.DataDirectory(IMAGE_DIR_TLS).iSize   
         invoke  ListOut,\
          ADDR  szDBoundIT, \
          [edi].OptionalHeader.DataDirectory(IMAGE_DIRY_BOUND).VirtualAddress, \
          [edi].OptionalHeader.DataDirectory(IMAGE_DIRY_BOUND).iSize    
         invoke  ListOut,\
          ADDR  szDIAT, \
          [edi].OptionalHeader.DataDirectory(IMAGE_DIR_IAT).VirtualAddress, \
          [edi].OptionalHeader.DataDirectory(IMAGE_DIR_IAT).iSize   
         invoke  ListOut,\
          ADDR  szDDelayIT, \
          [edi].OptionalHeader.DataDirectory(IMAGE_DIRECTORY_DELAY).VirtualAddress, \
          [edi].OptionalHeader.DataDirectory(IMAGE_DIRECTORY_DELAY).iSize     
         invoke  SendMessage,[hList],LB_ADDSTRING,0,ADDR  szNull 
         invoke  SendMessage,[hList],LB_ADDSTRING,0,ADDR  szSections 
         invoke  SendMessage,[hList],LB_ADDSTRING,0,ADDR  szNull 
         invoke  SendMessage,[hList],LB_ADDSTRING,0,ADDR  szSectHdr 
         invoke  SendMessage,[hList],LB_ADDSTRING,0,ADDR  szDivider 
         movzx   ebx,[edi].FileHeader.NumberOfSections 
         movzx   eax,[edi].FileHeader.SizeOfOptionalHeader 
         lea     esi,[edi+eax+18h]
         ASSUME  esi: PTR IMAGE_SECTION_HEADER
@@next_obj:        
         .WHILE EBX!=0
           invoke   wsprintf,ADDR  szStrBuffer, \
            ADDR  szSectDesc, \
            esi, \
            [esi].VirtualAddress, \
            [esi].VirtualSize, \
            [esi].PointerToRawData, \
            [esi].SizeOfRawData, \
            [esi].Characteristics
           invoke  SendMessage,[hList],LB_ADDSTRING,0,ADDR  szStrBuffer
           add     esi,sizeof IMAGE_SECTION_HEADER             
           dec ebx
         .ENDW 
         invoke  EnableWindow,[hFLoadBtn],FALSE
         invoke  EnableFBtn,TRUE
         invoke  EnableWindow,[hRLoadBtn],TRUE
@@lquit:
        ret 
doFLoad ENDP

doFUnLoad PROC USES ebx edi esi, hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
         invoke  UnmapViewOfFile,[ImageBase]
         invoke  CloseHandle,[hFileMap]
         invoke  CloseHandle,[hFile]
         .IF  [hServer]!=0
           invoke  SendMessage,[hRUnLoadBtn],BM_CLICK,NULL,NULL
         .ENDIF 
         invoke  EnableFBtn,FALSE
         invoke  EnableWindow,[hRLoadBtn],FALSE
         invoke  EnableWindow,[hFLoadBtn],TRUE
        ret 
doFUnLoad ENDP

doFResDump PROC USES ebx edi esi, hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
         invoke ShowResources,[hWnd],[ImageBase],FALSE
       ret 
doFResDump ENDP

doFITDump PROC USES ebx edi esi, hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
        invoke  ShowImports,[hWnd],[ImageBase],FALSE
       ret 
doFITDump ENDP

doRLoad PROC USES ebx edi esi, hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
        mov  [sa].nLength,sizeof SECURITY_ATTRIBUTES
        mov  [sa].bInheritHandle,TRUE
        invoke CreateFileMapping,cMMFromPageFile, \
         offset sa, \
         PAGE_READWRITE, \ 
         0, \
         1000, \
         offset szMMF
        .IF eax==0
            invoke  ErrorMessage,ERROR_COULD_NOT_CREATE_FILEMAP
            jmp @@rabort
        .ENDIF
        push eax
        pop  [hGate]
        call BuildFakeEnviroment
        mov  [sif].dwFlags,STARTF_USESHOWWINDOW
        mov  [sif].wShowWindow,SW_HIDE
        invoke CreateProcessA,offset szFilePath, \
         offset szCommandLine, \
         offset sa, \
         offset sa, \
         TRUE, \                           
         CREATE_SUSPENDED+DETACHED_PROCESS+CREATE_DEFAULT_ERROR_MODE, \
         NULL, \
         offset szCurrentDir, \
         offset sif, \
         offset pif
        .IF eax==0
            invoke  ErrorMessage,ERROR_COULD_NOT_CREATE_FILEMAP
            jmp @@rabort
        .ENDIF 
        mov  [SyncObjects],eax
        invoke GetVersion
        or   eax,eax
        jns  @@nt
        call HideParentPDB
@@nt:   mov eax,[hGate]
        invoke MapViewOfFile,eax,FILE_MAP_ALL_ACCESS,NULL,NULL,NULL
        .IF eax==0
           invoke  ErrorMessage,ERROR_COULD_NOT_MAPVIEW
           jmp     @@rabort
        .ENDIF 
        mov [hGateView],eax
        call InitGate
        invoke CreateEvent,ADDR sa,FALSE,FALSE,offset szSyncEvent
        .IF eax==0
           invoke  ErrorMessage,ERROR_COULD_CREATEEVENT
           jmp     @@rabort
        .ENDIF 
        mov  [SyncObjects+4],eax
        mov ebx,[EntryPoint]
        invoke ReadProcessMemory, \
         [pif].hProcess, \
         ebx,\ 
         [hGateView], \
         AppendSize, \
         offset cbBytes
        mov  eax,offset StartAppend
        invoke WriteProcessMemory, \
         [pif].hProcess, \
         ebx, \
         eax, \
         AppendSize, \
         offset cbBytes
        invoke FlushInstructionCache,[pif].hProcess,NULL,NULL
        lea  eax,offset SentryThreadProc
        lea  edx,offset SyncObjects
        invoke CreateThread,NULL,NULL,eax,edx,NORMAL_PRIORITY_CLASS,ADDR ThreadID
        invoke ResumeThread,[pif].hThread 
@@rabort:
        invoke UnmapViewOfFile,[hGateView]
        push [hGate]
        call CloseHandle
       ret 
doRLoad ENDP

doRUnLoad PROC USES ebx edi esi, hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
        invoke SendMessage,[hServer],WM_DESTROY,NULL,NULL
        invoke CloseHandle,[SyncObjects+4]
        invoke CloseHandle,[SyncObjects]
        invoke IsWindow,[hServer]
        .IF eax==0
          mov [hServer],eax
          invoke EnableRBtn,eax
          invoke EnableWindow,[hRLoadBtn],TRUE
        .ELSE
          ; error could not destroy server window
        .ENDIF
       ret 
doRUnLoad ENDP

doRResDump PROC USES ebx edi esi, hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
        invoke PostMessage,[hServer],WM_SPYSERVICE,SRV_SHOWRES,NULL
       ret 
doRResDump ENDP

doRITDump PROC USES ebx edi esi, hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
        invoke PostMessage,[hServer],WM_SPYSERVICE,SRV_SHOWIT,NULL
       ret 
doRITDump ENDP

doRIATScan PROC USES ebx edi esi, hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
        invoke NotImplemented
       ret  
doRIATScan ENDP

doAbout PROC USES ebx edi esi, hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
      invoke  MessageBox,[hWnd],ADDR szAboutMsg,ADDR szProgramName,0
      ret
doAbout ENDP

doBrowse PROC USES ebx edi esi,hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
        mov     [OFN].lStructSize,sizeof OPENFILENAME
        mov     eax,[hWnd]
        mov     [OFN].hWndOwner,eax
        mov     eax,[hInstance]
        mov     [OFN].hInstance,eax
        mov     [OFN].lpstrFilter,offset szOfnFilter
        mov     [OFN].lpstrFile,offset szFilePath
        mov     [OFN].nMaxFile,MAX_PATH-1
        mov     [OFN].Flags,OFN_PATHMUSTEXIST+OFN_FILEMUSTEXIST+OFN_HIDEREADONLY
        invoke  GetOpenFileName,ADDR OFN
        .IF EAX!=0
           invoke SetWindowText,[hTargetEdt],ADDR szFilePath
        .ENDIF  
       ret 
doBrowse ENDP

SentryThreadProc PROC lpthParam: DWORD
         invoke WaitForMultipleObjectsEx,2,[lpthParam],FALSE,INFINITE,FALSE
        .IF eax!=0
          invoke FindWindow,offset szSrvClassName,NULL
          .IF eax!=0
            mov   [hServer],eax
            invoke IsWindow,eax
            .IF eax!=0
               invoke SendMessage,[hServer],WM_SPYSERVICE,SRV_HANDSHAKE,NULL
               .IF eax!=-1
                 invoke  EnableRBtn,TRUE
                 invoke  EnableWindow,[hRLoadBtn],FALSE
                 invoke  ExitThread,0
                ret
               .ENDIF 
            .ENDIF
          .ENDIF
        .ENDIF
        invoke ErrorMessage,ERROR_COULD_SYNCRONIZE
        invoke SendMessage,[hMain],WM_COMMAND,IDC_RUnLoad,0
        invoke ExitThread,-1
       ret        
SentryThreadProc ENDP


;----- check headers and returd ofs of NtHeaders ---------------------------------------
;  on entry: EDI = base address of MMF
;  on exit : ESI = start of pe header, EAX = 0 = valid PE
;  trashed : EAX,EDI,CF         
GetNtHeader:
        push    ebp
        mov     ebp,esp
        push    ebp                                      ; save safe ESP 
        push    offset @@on_PE_except                    ; our simple handler
        push    fs:[0]                                   ; save previous frame 
        mov         fs:[0],esp                             ; establish our SEH frame
        cmp     word ptr [edi],IMAGE_DOS_SIGNATURE       ; check MZ signature
        jnz     short @@not_PE
        ASSUME  edi : PTR IMAGE_DOS_HEADER
        mov     eax,[edi].e_lfanew
        add     edi,eax
        cmp     dword ptr [edi],IMAGE_NT_SIGNATURE       ; check PE signature
        jb      short @@not_PE 
        ASSUME  edi : PTR IMAGE_NT_HEADERS                                  
        mov     eax,dword ptr [edi].FileHeader.Characteristics
        not     al
        or      al,IMAGE_FILE_EXECUTABLE_IMAGE           ; check for executable flag
        jz      short @@is_PE
        or      ax,IMAGE_FILE_DLL
        jz      short @@not_PE
@@is_PE:xor     eax,eax
        jmp     short @@valid_pe
@@on_PE_except: 
        mov     eax,[esp+8]                              ; get ERR structure
        mov     ebp,[eax+8]                              ; ERR + 8 = safe ESP 
@@not_PE:
        stc
        sbb     eax,eax
@@valid_pe:
        pop     dword ptr fs:[0]                         ; remove SEH frame
        mov     esp,ebp       
        pop     ebp
      ret

EnableFBtn PROC bEnable: DWORD
        invoke  EnableWindow,[hFUnLoadBtn],[bEnable]
        invoke  EnableWindow,[hFResTBtn],[bEnable]
        invoke  EnableWindow,[hFImportBtn],[bEnable]
      ret
EnableFBtn ENDP      

EnableRBtn PROC bEnable: DWORD
        invoke  EnableWindow,[hRUnLoadBtn],[bEnable]
        invoke  EnableWindow,[hRResTBtn],[bEnable]
        invoke  EnableWindow,[hRImportBtn],[bEnable]
        invoke  EnableWindow,[hRIATBtn],[bEnable]
      ret
EnableRBtn ENDP

HideParentPDB:
        push    ebp
        mov     ebp,esp
        push    ebp                                      
        push    offset @@on_pdb_x
        push    dword ptr fs:[0]                         
        mov     fs:[0],esp                               
        call 	GetCurrentProcessId                     
        mov	ebx,[esp-8h]                            
        xor     ebx,eax
        mov     esi,[pif].dwProcessId
        xor     esi,ebx
        ASSUME esi : PTR PROCESS_DATABASE
        cmp	dword ptr [esi].cType,K32OBJ_PROCESS
	jnz 	@@not_pdb
        invoke  FindWindow,offset szProgmam,NULL
        invoke  GetWindowThreadProcessId,eax,offset ProcessID
        mov     eax,[ProcessID]
        xor     eax,ebx
        ; ASSUME eax : PTR PROCESS_DATABASE
        cmp	dword ptr [eax].PROCESS_DATABASE.cType,K32OBJ_PROCESS
	jnz 	@@not_pdb
        mov	[esi].ParentPDB,eax
        jmp     @@pdb
@@on_pdb_x:
        mov     eax,[esp+8]                              
        mov     ebp,[eax+8]
@@not_pdb:        
        stc
        sbb     eax,eax
@@pdb:
        pop     dword ptr fs:[0]
        mov     esp,ebp       
        pop     ebp
       ret

BuildFakeEnviroment:
        mov     esi,offset szCommandLine
        mov     byte ptr [esi],22h
        mov     edi,offset szCurrentDir 
        inc     esi
        invoke  _strcpy,offset szFilePath,esi
        invoke  _strcpy,offset szFilePath,edi
        invoke  _strlen,edi
        add     esi,ecx
        mov     word ptr [esi],0022h
        lea     esi,[ecx+edi-1]
@@scn:        
        cmp     byte ptr [esi],'\'
        jz      @@df
        dec     esi
        cmp     esi,edi
        ja      @@scn
@@df:        
        mov     byte ptr [esi+1],0
      ret        

InitGate:
        invoke GetModuleHandle,offset szKernel32
	mov ebx, eax
        invoke GetProcAddress,ebx,offset szLoadLibraryA
	mov [_LoadLibraryA], eax
        invoke GetProcAddress,ebx,offset szGetProcAddress
	mov [_GetProcAddress], eax 
        invoke GetProcAddress,ebx,offset szExitProcess
        mov [_ExitProcess], eax 
       ret

ListOut PROC lpszMsg: DWORD, Value1: DWORD, Value2: DWORD
        invoke wsprintf,ADDR  szStrBuffer,[lpszMsg],[Value1],[Value2]
        invoke  SendMessage,[hList],LB_ADDSTRING,0,ADDR szStrBuffer
      ret  
ListOut ENDP

ErrorMessage PROC ErrorID:DWORD
        invoke  LoadString,[hInstance],[ErrorID],offset szStrBuffer,szStrBufferl
        .IF eax==0
          lea     eax,szStrBuffer  
        .ELSE
          lea     eax,szGenErrMsg
        .ENDIF
        invoke MessageBox,0,eax,ADDR szProgramName,MB_OK+MB_ICONHAND
       ret
ErrorMessage ENDP

_strlen PROC src: DWORD 
        mov     ecx,[src]
        mov     edx,ecx
@@slen: inc     ecx
        test    ecx,3
        jz      @@dwln
        cmp     byte ptr [ecx],0
        jne     @@slen
        jmp     @@len
@@dwln: mov     ebx,[ecx]       
        add     ecx,4           
        test    bl,bl           
        jz      @@db              
        test    bh,bh           
        jz      @@dw              
        test    ebx,0ff0000h    
        jz      @@dd              
        test    ebx,0ff000000h  
        jnz     @@dwln 
        inc     ecx
@@dd:   inc     ecx
@@dw:   inc     ecx
@@db:   sub     ecx,4
@@len:  sub     ecx,edx
      ret 
_strlen ENDP

_strcpy PROC src: DWORD , dest: DWORD
	mov	ecx,[src]
	mov	edx,[dest]	
	push	edx		
	test	edx,3		
	jz	short @@lcpy
@@algn:	mov	al,[ecx]
	inc	ecx
	mov	[edx],al
	inc	edx
	test	al,al
	jz	short @@ret
	test	edx,3
	jnz	short @@algn
@@lcpy:	mov	eax,[ecx]
	add	ecx,4
	or	al,al
	jz	short @@one
	or	ah,ah
	jz	short @@two
	test	eax,0ff0000h
	jz	short @@three
	mov	dword ptr [edx],eax
	add	edx,4
	shr	eax,24
	jnz	short @@lcpy
	pop	eax
       ret
@@three:mov	byte ptr [edx+2], 0
@@two:	mov	word ptr [edx], ax
@@ret:	pop	eax		
       ret
@@one:	mov	byte ptr [edx], al
	pop	eax		
       ret
_strcpy	ENDP 

NotImplemented PROC
       invoke  MessageBoxA,NULL,ADDR szNotImplemented,ADDR szProgramName,MB_ICONEXCLAMATION
      ret
NotImplemented ENDP


StartAppend: 
	push eax
	pushad				 
 	call   delta			 
delta:	pop    ebp	
	sub    ebp,(delta-StartAppend)
        lea    eax,[(Gate-StartAppend)+ebp]
        push   eax
        call   dword ptr [(_LoadLibraryA-StartAppend)+ebp]
        .IF    eax!=0 
          lea    ebx,[(GateEntry-StartAppend)+ebp] 
          push   ebx
          push   eax
          call   dword ptr [(_GetProcAddress-StartAppend)+ebp]
           .IF    eax!=0 
             mov   ebx,(StopAppend-StartAppend)
             mov   edx,[(hGate-StartAppend)+ebp]             
             mov   esi,[(EntryPoint-StartAppend)+ebp]	 
             mov   [esp+20h],esi
             jmp   eax
           .ENDIF
        .ENDIF     
        push   -1
        call   dword ptr [(_ExitProcess-StartAppend)+ebp]         

        _LoadLibraryA       DD 0
	_GetProcAddress     DD 0
        _ExitProcess        DD 0
        Gate                DB 'spydll',0
	GateEntry           DB "GateEntry",0
	EntryPoint          DD 0
	hGate               DD 0
StopAppend:  

end start


