;**************************************************
; RingZer0 present:
;
; Another IPC method
;
; Written By GEnius
;**************************************************


;***********************************************************
; Il codice presente  riportato solo per scopo didattico
; non penso sia molto utile, almeno in questa versione!
; Limitazioni dei servizi del vxd:
; - solo un blocco alla volta pu essere reso pubblico
; -  possibile rendere pubblici solo blocchi di grandezza
; multipla di 4kb (Se il vostro blocco da rendere 
; di 3kb il servizio funzioner comunque ma verr reso pubblico
; anche il kb successivo! Con conseguente possibilit
; da parte degli altri processi di scrivere in quel kb che non 
; dovrebbe riguardare loro)
; - nessun controllo degli errori!
;
;Breve descrizione dei servizi per il server messi a 
;disposizione da RZvxd.vxd:
;
; IPC_SHARE_BLOCK
; servizio usato per rendere pubblico un blocco di
; memoria. Parametri:
;
; InputBuffer deve puntare ad una struttura siffatta:
; DD IndirizzoBuffer -  l'indirizzo del blocco
; DD SizeOfBuffer -  la grandezza del blocco in unit di 4kb
; NB: SizeOfBuffer funziona in unit di 4kb cio
; SizeOfBuffer=1 significa blocco di 4kb 
; Ho scelto di usare 4kb come unit base
; solo per semplificare il codice, visto che
; la grandezza di una pagina  di 4kb!
; OutputBuffer Buffer abastanza grande da ricevere 4 byte
; riceve 1 se il servizio  andato a buon fine 
; 0 se invece il blocco  gi stato definito o c' stato un errore
;
; IPC_LEAVE_BLOCK
; servizio usato per non far vedere pi il blocco
; agli altri processi. Parametri: Nessuno :)

.486
locals
jumps

UNICODE = 0
.model flat,STDCALL


extrn	GetProcAddress		: PROC
extrn   GetCurrentProcess	: PROC
extrn   DeviceIoControl		: PROC

include W32.inc           

L                       EQU <LARGE>
IPC_SHARE_BLOCK         EQU 1
IPC_LEAVE_BLOCK         EQU 2
IPC_GET_SHARE_BLOCK     EQU 3
IPC_BLOCK_PRESENT       EQU 4

.data
;**************** blocco che verr reso pubblico *********************
provabuff       dd offset msg1-offset provabuff ;indirizzi relativi
                dd offset msg2-offset provabuff
msg1            db 'Messaggio dal Server:',0
msg2            db 'GEnius... funziona!!!!',0
;*********************************************************************

IndirizzoBuffer dd offset provabuff
SizeOfBuffer    dd 1

Aspetta         db 'Il Blocco  stato reso pubblico!',0
Server          db 'Server: ',0

Inputbuffer     dd  offset IndirizzoBuffer
hInst           dd 0

ControlCode     dd 1
vxdReturn       dd 4 dup(0) ;buffer per ricevere dati dal vxd
Vxd_Handle      dd 0 ;Handle del Vxd
VxDName         db '\\.\RZvxd.vxd',0 
VxDErrorTxT     db 'Cannot load RingZ.vxd :(',0
ErrHeader       db 'Errore',0

.code


start:

        push    L 0
        call    GetModuleHandle         
        mov     [hInst], eax            ; hInstance non mi serve per  un'abitudine!

        call    OpenVxD                 ;Open the Baby!
        cmp     eax,-1
        jne     NoError
        call    VxDError		;minghia!
        jmp exit

NoError:
        mov ControlCode, IPC_SHARE_BLOCK
	Call VxDUse ;rendiamo pubblico il blocco
        cmp [vxdReturn],0 
        jz exit
        Call MessageBox, 0, offset Aspetta, offset Server,0 ;pausa
        mov ControlCode,IPC_LEAVE_BLOCK
        Call VxDUse  ;basta con i blocchi publlici! il blocco non  + pubblico!

        Call CloseVxD ;Bye Bye Baby;)

exit:
        push    LARGE-1
        call    ExitProcess ; fine del server

;-------------------------------------------------------------------------------------------
; Procedure per la comunicazione con il VXD
; Semplici ed intuitive!
;-------------------------------------------------------------------------------------------

OpenVxD PROC ;Apre il vxd
        push    0
        push    L FILE_FLAG_DELETE_ON_CLOSE
        push    0
        push    0
        push    0
        push    0
        push    offset VxDName
        call    CreateFileA ;Uaoo un semplice Createfile!!
        mov     Vxd_Handle,eax 
        cmp     eax,-1
        je      VxDError
        ret
OpenVxD ENDP

CloseVxD PROC ; Chiude il Vxd....Bye Bye Baby :D
         push    [Vxd_Handle]
         call    CloseHandle
         mov     eax,1
         ret                     ;All Ok!!
CloseVxD ENDP

VxDError PROC ; Visualizza un dialogbox con il messaggio di errore
         push    L 0
         call    MessageBeep
         push    L MB_ICONEXCLAMATION
         push    offset ErrHeader
         push    offset VxDErrorTxT
         push    0
         call    MessageBoxA
         ret
VxDError ENDP

VxDUse  PROC ; Questa  la proc + importante chiama un servizio del vxd
; il servizio attuale da chiamare si trova nella variabile ControlCode
; Inputbuffer  il puntatore ai parametri di input del servizio
; VxdReturn torna il risultato del servizio
	push    L NULL
        push    0                       ;lp to bytes returned
        push    0                       ;size of output buffer
        push    offset vxdReturn        ;lp to output data
        push    0                       ;size of input buffer
        push    offset Inputbuffer      ;lp to input data
        push    [ControlCode]           ;Control code 
        push    [Vxd_Handle]
        call    DeviceIoControl
        ret
VxDUse  ENDP

end start
