.586
.MODEL FLAT, STDCALL
OPTION CASEMAP :NONE

INCLUDE \USER\W32ASM\MASM\INCLUDE\WINDOWS.INC
INCLUDE \USER\W32ASM\MASM\INCLUDE\KERNEL32.INC
INCLUDE \USER\W32ASM\MASM\INCLUDE\USER32.INC
INCLUDE \USER\W32ASM\MASM\INCLUDE\GDI32.INC
INCLUDE \USER\W32ASM\MASM\INCLUDE\COMCTL32.INC


INCLUDELIB \USER\W32ASM\MASM\LIB\KERNEL32.LIB
INCLUDELIB \USER\W32ASM\MASM\LIB\USER32.LIB
INCLUDELIB \USER\W32ASM\MASM\LIB\GDI32.LIB
INCLUDELIB \USER\W32ASM\MASM\LIB\COMCTL32.LIB

return MACRO arg
  mov eax,arg
 ret
ENDM

wsprintfA     PROTO C :DWORD, :VARARG
wsprintf equ <wsprintfA>
ResDlg        PROTO :DWORD,:DWORD,:DWORD,:DWORD
ImportsDlg    PROTO :DWORD,:DWORD,:DWORD,:DWORD
GetNtHeader   PROTO :DWORD
GetModuleET   PROTO :DWORD
GetModuleIT   PROTO :DWORD
ShowResources PROTO :DWORD,:DWORD,:DWORD
ShowImports   PROTO :DWORD,:DWORD,:DWORD
EnumResources PROTO :DWORD
EnumModules   PROTO :DWORD
strcpy        PROTO :DWORD,:DWORD
strlen        PROTO :DWORD

.CONST

RESOURCES_DIR_DESCRIPTOR STRUCT 
 BaseAddr       DWORD ?
 ImageBase      DWORD ?
 OwnerSection   DWORD ?
 blMapped       DWORD ?
RESOURCES_DIR_DESCRIPTOR ENDS

IMPORTS_DIR_DESCRIPTOR STRUCT 
 BaseAddr       DWORD ?
 ImageBase      DWORD ?
 OwnerSection   DWORD ?
 blMapped       DWORD ?
IMPORTS_DIR_DESCRIPTOR ENDS

MODREF STRUCT
 BaseAddr       DWORD ?
 Exports        DWORD ?
 szModuleName   DB MAX_PATH dup (?)
MODREF ENDS 

WM_SPYSERVICE = WM_USER+1
SRV_HANDSHAKE = 00000001 
SRV_SHOWRES   = 00000002 
SRV_SHOWIT    = 00000003

.DATA

szClassName    DB "PESPYSERVER",0
szCliClassName DB "PESPYCLASS",0
szSyncEvent    DB "SpySyncEvent",0
szConnection   DB "Connection Established",0

szResEntry    DB "Offset:%08lX Size :%08lX",0
szResID       DB "%08ld",0
szOrdinals    DB "Ord 0x00000000",0
szNoEntries   DB "Not imports for IAT entry",0

tResDecode  DD  offset szCursor
            DD  offset szBitmap
            DD  offset szIcon
            DD  offset szMenu
            DD  offset szDialog      
            DD  offset szString
            DD  offset szFDir
            DD  offset szFont
            DD  offset szAccel
            DD  offset szRcData      
            DD  offset szMsgTbl
            DD  offset szGrpCrs
            DD  offset szUndef
            DD  offset szGrpIcn
            DD  offset szUndef
            DD  offset szVers
            DD  offset szUndef
   szCursor DB "CURSOR",0
   szBitmap DB "BITMAP",0
   szIcon   DB "ICON",0
   szMenu   DB "MENU",0
   szDialog DB "DIALOG",0
   szString DB "STRING",0
   szFDir   DB "FONTDIR",0
   szFont   DB "FONT",0
   szAccel  DB "ACCELERATORS",0
   szRcData DB "RCDATA",0
   szMsgTbl DB "MESSAGETABLE",0
   szGrpCrs DB "GROUP CURSOR",0
   szGrpIcn DB "GROUP ICON",0
   szVers   DB "VERSION",0
   szUndef  DB "UNKNOWN",0


.DATA?

szStrBuffer      DB     260 dup (?)
szStrBufferl     EQU    ($-szStrBuffer)-1
szSectName       DB     9   dup (?)

wc              WNDCLASSEX <?>
hInstance   	HANDLE ?
hInstDLL   	HANDLE ?
hTreeView       HWND   ?
hServer         HWND   ?
hGateView       DD     ?
lpPEHeader      DD     ?
tvinsert        TV_INSERTSTRUCT     <?>
hGate           HANDLE ?
SentryEvent     HANDLE ?
hSpyClient      HWND   ?
cbBytes 	DD     ?
TID	        DD     ?
PID             DD     ?
ThreadID        DD     ?
cModCount       DD     ?
lpModRefs       DD     ?

ASSUME  fs:nothing

INCLUDE PESPY.INC      

.CODE
                                  
LibMain PROC hInst:DWORD, dwReason:DWORD, dwReserv:DWORD
        mov eax,[dwReason]
        .IF     eax==DLL_THREAD_ATTACH
        .ELSEIF eax==DLL_PROCESS_ATTACH
          invoke GetModuleHandle,NULL
          mov  [hInstance],eax
          mov  eax,hInst
          mov  [hInstDLL],eax
          invoke GlobalAlloc,GMEM_ZEROINIT + GMEM_FIXED,3000
          mov  [lpModRefs],eax
        .ELSEIF eax==DLL_PROCESS_DETACH
          .IF lpModRefs!=0
             invoke GlobalFree,lpModRefs
          .ENDIF
        .ELSEIF eax==DLL_THREAD_DETACH
        .ENDIF
        return TRUE
       ret  (3*4)
LibMain ENDP        

GateEntry PROC
        mov   [hGate],edx
        invoke MapViewOfFile,edx,FILE_MAP_ALL_ACCESS,0,0,0
        mov   [hGateView],eax
        invoke GetCurrentProcess
	mov  edi,eax
	invoke WriteProcessMemory, \
         edi, \
         esi, \
         [hGateView], \
         ebx, \
         offset cbBytes
         invoke FlushInstructionCache,edi,NULL,NULL
         invoke GetCurrentThread
         invoke DuplicateHandle,edi,eax,edi,ADDR TID,0,TRUE,DUPLICATE_SAME_ACCESS	
         mov eax,offset SentryThreadProc
         invoke CreateThread,NULL,NULL,eax,edi,NORMAL_PRIORITY_CLASS,ADDR ThreadID
	popad
       ret
GateEntry ENDP

SentryThreadProc PROC lpthParam: DWORD
        LOCAL msg  :MSG
        LOCAL hWnd :HANDLE
 
        invoke WaitForInputIdle,[lpthParam],5000
        invoke SuspendThread,[TID]
        invoke FindWindow,offset szCliClassName,NULL
        .IF eax!=0
          mov   [hSpyClient],eax
          invoke IsWindow,eax
         .IF eax!=0
           mov   [wc].cbSize,sizeof WNDCLASSEX
           mov   [wc].lpfnWndProc,offset SrvWndProc
           mov   [wc].lpszClassName,offset szClassName
           invoke RegisterClassEx,ADDR wc
           invoke CreateWindowEx,NULL, \
            offset szClassName, \
            NULL, \
            NULL, \
            0,0,0,0, \
            NULL, \
            NULL, \
            [hInstance], \
            0
           .IF eax!=0
             mov  [hServer],eax 
             .WHILE TRUE
               invoke GetMessage,ADDR msg,NULL,0,0
             .BREAK .IF !eax
               invoke TranslateMessage,ADDR msg
               invoke DispatchMessage,ADDR msg
             .ENDW
           .ENDIF 
         .ENDIF
        .ENDIF
        invoke ExitProcess,-1
       ret        
SentryThreadProc ENDP


SrvWndProc PROC USES ebx edi esi, hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
        .IF [uMsg]==WM_CREATE
           invoke OpenEvent,EVENT_MODIFY_STATE,FALSE,offset szSyncEvent
           push   eax
           invoke SetEvent,eax
           call   CloseHandle
          .ELSEIF [uMsg]==WM_DESTROY
            invoke ResumeThread,[TID]
            invoke CloseHandle,[TID]
            invoke PostQuitMessage,0
            invoke ExitProcess,0
          .ELSEIF [uMsg]==WM_SPYSERVICE
           .IF  [wParam]==SRV_HANDSHAKE
              ; invoke EnumModules,lpModRefs
            .ELSEIF [wParam]==SRV_SHOWRES
              invoke ShowResources,[hSpyClient],[hInstance],TRUE
            .ELSEIF [wParam]==SRV_SHOWIT
              invoke ShowImports,[hSpyClient],[hInstance],TRUE
           .ENDIF   
          .ELSE
            invoke DefWindowProc,[hWnd],[uMsg],[wParam],[lParam]
           ret
        .ENDIF    
        xor eax,eax
      ret
SrvWndProc ENDP

;----- validate basic PE signatures and return a ptr to Header -------------------------
;  on entry: lpImageBase
;  on exit : EDI,EAX = ptr to PE NtHeaders ; EAX=-1 -> failure
;  trashed : ASSUME ALL (on xfault)
GetNtHeader PROC lpImageBase: DWORD
        push    ebp                                      ; save safe ESP 
        push    offset @@on_PE_except                    ; our simple handler
        push    fs:[0]                                   ; save previous frame 
        mov     fs:[0],esp                               ; establish our SEH frame
        mov     eax,[lpImageBase]
        cmp     word ptr [eax],IMAGE_DOS_SIGNATURE       ; check MZ signature
        jnz     @@not_PE
        add     eax,[eax].IMAGE_DOS_HEADER.e_lfanew
        cmp     dword ptr [eax],IMAGE_NT_SIGNATURE       ; check PE signature
        jnz     @@not_PE 
        ASSUME  eax : PTR IMAGE_NT_HEADERS                                  
        movzx   ecx,word ptr [eax].FileHeader.SizeOfOptionalHeader  ; check if PE has not 
        jcxz    @@not_PE                                            ; been erased and get
        mov     ecx,dword ptr [eax].OptionalHeader.SizeOfHeaders    
        jcxz    @@not_PE
        movzx   ecx,word ptr [eax].FileHeader.NumberOfSections
        ASSUME  eax : NOTHING
        jcxz    @@not_PE
        jmp     @@valid_PE
@@on_PE_except: 
        mov     eax,[esp+8]                              ; get ERR structure
        mov     ebp,dword ptr [eax+08h]                  ; ERR + 8 = safe ESP 
        mov     esp,ebp
@@not_PE:
        push    -1
        pop     eax
@@valid_PE:
        pop     dword ptr fs:[0]                         ; remove SEH frame
      ret
GetNtHeader ENDP      


GetModuleET PROC lpImageBase: DWORD
       push  ebx
       push  esi
       push  edi 
       invoke GetNtHeader,lpImageBase
       .IF eax!=-1
         mov  eax,[eax].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory(IMAGE_DIR_EXPORT).VirtualAddress
       .ENDIF
       pop   edi
       pop   esi
       pop   ebx
      ret 
GetModuleET ENDP


GetModuleIT PROC lpImageBase: DWORD
       push  ebx
       push  esi
       push  edi 
       invoke GetNtHeader,lpImageBase
       .IF eax!=-1
         mov  eax,[eax].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory(IMAGE_DIR_IMPORT).VirtualAddress
       .ENDIF
       pop   edi
       pop   esi
       pop   ebx
      ret 
GetModuleIT ENDP

;----- try to find a section that contain a given RVA ---------------------------------------------
;  on entry: EAX = RVA ; EDI = lpPEHeader
;  on exit : ESI = ptr to section header
;  trashed : ASSUME ALL but EBP
GetSection:
        ASSUME  edi : PTR IMAGE_NT_HEADERS
        movzx   ecx,word ptr [edi].FileHeader.NumberOfSections
        .IF     ecx!=0
          movzx   edx,word ptr [edi].FileHeader.SizeOfOptionalHeader
          lea     esi,[edi+edx+18h]
          ASSUME  esi : PTR IMAGE_SECTION_HEADER
          mov   edx,eax
          .WHILE  ecx!=0
            sub    eax,[esi].VirtualAddress 
            jz     @@sc_found
            cmp    eax,[esi].VirtualSize
            jb     @@sc_found
            add    esi,sizeof IMAGE_SECTION_HEADER
            dec    ecx
            mov    eax,edx
          .ENDW
        .ENDIF
        xor     esi,esi
@@sc_found:
      ret  

;----- convert an RVA to a corresponding filebased ofs --------------------------------------------
;  on entry: EAX = RVA ; EDI = lpPEHeader
;  on exit : EAX = raw offset 
;  trashed : ASSUME ALL but EBP
Rva2Raw: 
        call    GetSection
        .IF esi==0
          xor     eax,eax
        .ELSE
          add     eax,[esi].PointerToRawData       
        .ENDIF
       ret 


;----- retrive RVA of resource dir and displays a dialog ------------------------------------------
;  on entry: Owner = parent window ; ImageBase = module imagebase ; Mapped = filebase/mapped flag
;  on exit : EAX = 0 no errors
;  trashed : ASSUME ALL
ShowResources PROC Owner: DWORD, ImageBase: DWORD,Mapped: DWORD
          LOCAL  ResDirectory : RESOURCES_DIR_DESCRIPTOR
                   
          invoke  GetNtHeader,[ImageBase]
          ASSUME  edi : PTR IMAGE_NT_HEADERS
          mov     edi,eax
          mov     eax,[edi].OptionalHeader.DataDirectory(IMAGE_DIR_RESOURCE).VirtualAddress
          mov     ebx,eax
          .IF     eax!=0
            call    GetSection
            .IF     esi!=0
              ASSUME  esi : PTR IMAGE_SECTION_HEADER
              mov     [ResDirectory].OwnerSection,esi
              mov     eax,[Mapped]
              mov     [ResDirectory].blMapped,eax
              mov     edi,[ImageBase]
              mov     [ResDirectory].ImageBase,edi
              .IF     eax!=0
                add     edi,ebx
              .ELSE
                add     edi,edx
                sub     edi,[esi].VirtualAddress
                add     edi,[esi].PointerToRawData
              .ENDIF  
              mov     [ResDirectory].BaseAddr,edi
              invoke DialogBoxParam,[hInstDLL],IDD_RESEXPL,[Owner],ADDR ResDlg,ADDR ResDirectory
             ret  
           .ENDIF  
          .ENDIF   
           return ERROR_RESOURCES_NOT_PRESENT
         ret 
ShowResources ENDP


;----- retrive RVA of resource dir and displays a dialog ------------------------------------------
;  on entry: Owner = parent window ; ImageBase = module imagebase ; Mapped = filebase/mapped flag
;  on exit : EAX = 0 no errors
;  trashed : ASSUME ALL
ResDlg PROC USES ebx esi edi , hDlg:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
          LOCAL hBitmap    : HANDLE
          LOCAL hImageList : HANDLE
          
         .IF    [uMsg]==WM_INITDIALOG
           invoke GetDlgItem,[hDlg],IDC_RESTREE
           mov    [hTreeView],eax
           invoke ImageList_Create,16,16,ILC_COLOR16+ILC_MASK,18,2     ; create an masked imagelist 16x16x8bit 
           mov    [hImageList],eax
           invoke LoadBitmap,[hInstDLL],IDB_TREENODES                  ; note: dll hModule not hInstance ;)
           mov    [hBitmap],eax                                     
           invoke ImageList_AddMasked,[hImageList],[hBitmap],NULL    
           invoke DeleteObject,[hBitmap]                               ; avoid GDI mem leak 
           invoke SendMessage,[hTreeView],TVM_SETIMAGELIST,0,[hImageList]
           mov    ebx,[lParam]                                         ; retrive resources descriptor    
           ASSUME ebx : PTR RESOURCES_DIR_DESCRIPTOR
           mov    esi,[ebx].OwnerSection                              
           mov    edi,offset szSectName
           movsd                                                       ; faster than _wsprintf %.s8
           movsd
           invoke  SetDlgItemText,[hDlg],IDC_RESSECT,offset szSectName ; show owner section name
           mov    eax,[ebx].BaseAddr
           .IF   [ebx].blMapped==FALSE
             sub   eax,[ebx].ImageBase                                 ; filebased -> adjust ptr
           .ENDIF 
           mov    edx,offset szStrBuffer
           call   _ulonghex
           invoke SetDlgItemText,[hDlg],IDC_RESBASE,offset szStrBuffer ; show base res address
           mov    edi,[ebx].BaseAddr
           ASSUME  edi: PTR IMAGE_RESOURCE_DIRECTORY
           movzx  eax,word ptr [edi].NumberOfNamedEntries              ; show number of lev 1 (types dir) entries
           add    ax,word ptr [edi].NumberOfIdEntries
           mov    edx,offset szStrBuffer
           call   _ulonghex
           invoke  SetDlgItemText,[hDlg],IDC_RESNID,offset szStrBuffer
           invoke  EnumResources,ebx
           invoke SetForegroundWindow,[hDlg]                           ; set focus to our dialog
           ASSUME ebx : NOTHING
           return TRUE
         .ELSEIF [uMsg]==WM_COMMAND
           .IF    [wParam]==IDOK || [wParam]==IDCANCEL
             invoke ImageList_Destroy,[hImageList]                     ; dispose imagelist
             invoke EndDialog,hDlg,TRUE
             return TRUE
           .ENDIF
         .ELSE
           return FALSE
         .ENDIF
       ret                     
ResDlg ENDP


;----- retrive RVA of imports dir and displays a dialog ------------------------------------------
;  on entry: Owner = parent window ; ImageBase = module imagebase ; Mapped = filebase/mapped flag
;  on exit : EAX = 0 no errors
;  trashed : ASSUME ALL
ShowImports PROC Owner: DWORD, ImageBase: DWORD,Mapped: DWORD
          LOCAL  ImportsDirectory : IMPORTS_DIR_DESCRIPTOR 
                   
          invoke  GetNtHeader,[ImageBase]
          ASSUME  edi : PTR IMAGE_NT_HEADERS
          mov     edi,eax
          mov     eax,[edi].OptionalHeader.DataDirectory(IMAGE_DIR_IMPORT).VirtualAddress
          mov     ebx,eax
          .IF     eax!=0
            call    GetSection
            .IF     esi!=0
              ASSUME  esi : PTR IMAGE_SECTION_HEADER
              mov     [ImportsDirectory].OwnerSection,esi
              mov     eax,[Mapped]
              mov     [ImportsDirectory].blMapped,eax
              mov     edi,[ImageBase]
              mov     [ImportsDirectory].ImageBase,edi
              .IF     eax!=0
                add     edi,ebx
              .ELSE
                add     edi,edx
                sub     edi,[esi].VirtualAddress
                add     edi,[esi].PointerToRawData
              .ENDIF  
              mov     [ImportsDirectory].BaseAddr,edi
              invoke DialogBoxParam,[hInstDLL],IDD_ITEXPL,[Owner],ADDR ImportsDlg,ADDR ImportsDirectory
             ret  
           .ENDIF  
          .ENDIF   
           return ERROR_IMPORTS_NOT_PRESENT
         ret 
ShowImports ENDP


;----- try to find a exported function that match passed address ----------------------------------
;  on entry: fnAddr = (IAT)->function address
;  on exit : EAX = function name ; EAX = NULL if not found
;  trashed : ALL but windows aware regs 
ExportNameByAddress PROC USES ebx esi edi , fnAddr: DWORD
          
          LOCAL mbi        : MEMORY_BASIC_INFORMATION 
          
          ; retrive owner region in the process's address space
          invoke VirtualQuery,[fnAddr],ADDR mbi,sizeof MEMORY_BASIC_INFORMATION  
          mov    ebx,[mbi].AllocationBase
          .IF [mbi].State!=MEM_FREE && [mbi].State!=MEM_RESERVE && [mbi].BaseAddress!=0
            invoke GetModuleET,ebx                      ; is pe module with a valid ET ?
            .IF eax!=-1 && eax!=0
              lea    esi,[eax+ebx]
              ASSUME esi : PTR IMAGE_EXPORT_DIRECTORY                   
              mov    ecx,[esi].NumberOfFunctions        ; number of functions exported 
              mov    edi,[esi].AddressOfFunctions     
              add    edi,ebx           
              .WHILE ecx > 0                            ; lookup AddressOfFunctions for a matching address
                dec    ecx
                mov    eax,dword ptr [edi+ecx*4]
                add    eax,ebx
                .IF eax==[fnAddr]                       ; ecx = index = ordinal - base
                  mov    edx,[esi].NumberOfNames        ; number of functions exported by name
                  mov    edi,[esi].AddressOfNameOrdinals
                  add    edi,ebx
                  xor    eax,eax
                  .WHILE edx >0                         ; lookup AddressOfNameOrdinals for a matching index
                    dec    edx
                    .IF word ptr [edi+edx*2]==cx                    
                      mov    edi,[esi].AddressOfNames
                      add    edi,ebx
                      mov    edi,dword ptr [edi+edx*4]  ; lpszFunctionName =  AddressOfNames[edx] + imagebase
                      add    edi,ebx
                      invoke strcpy,edi,offset szStrBuffer
                      mov    eax,offset szStrBuffer
                     ret
                    .ENDIF
                  .ENDW
                  .IF eax==0                            ; lpszFunctionName = NULL -> exported by ordinal
                    mov    edx,offset szOrdinals+6      
                    mov    eax,ecx
                    add    eax,[esi].nBase             
                    call   _ulonghex
                    mov    eax,offset szOrdinals
                   ret 
                  .ENDIF   
                .ENDIF 
              .ENDW
            .ENDIF
          .ENDIF  
         xor    eax,eax 
       ret
ExportNameByAddress ENDP


ImportsDlg PROC USES ebx esi edi , hDlg:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

          LOCAL tvParent   : HANDLE
          LOCAL hBitmap    : HANDLE
          LOCAL hImageList : HANDLE
          LOCAL IsMapped   : DWORD
          
         .IF    [uMsg]==WM_INITDIALOG
           invoke GetDlgItem,[hDlg],IDC_ITTREE                         ; set imagelist for treeview ctrl
           mov    [hTreeView],eax
           invoke ImageList_Create,16,16,ILC_COLOR16+ILC_MASK,18,2     ; create an masked imagelist 16x16x8bit 
           mov    [hImageList],eax
           invoke LoadBitmap,[hInstDLL],IDB_TREENODES                  ; note: dll hModule not hInstance ;)
           mov    [hBitmap],eax
           invoke ImageList_AddMasked,[hImageList],[hBitmap],NULL
           invoke DeleteObject,[hBitmap]                               ; avoid GDI mem leak
           invoke SendMessage,[hTreeView],TVM_SETIMAGELIST,0,[hImageList]
           mov    ebx,[lParam]                                         ; retrive resources descriptor    
           ASSUME ebx : PTR IMPORTS_DIR_DESCRIPTOR
           push   [ebx].blMapped
           pop    [IsMapped]
           mov    esi,[ebx].OwnerSection                              
           ASSUME esi : PTR IMAGE_SECTION_HEADER
           mov    edi,offset szSectName
           movsd                                                       ; faster than _wsprintf %.s8
           movsd
           invoke  SetDlgItemText,[hDlg],IDC_ITSECT,offset szSectName  ; show owner section name
           mov    eax,[ebx].BaseAddr
           mov    edi,[ebx].ImageBase
           .IF   [ebx].blMapped==FALSE
             mov    esi,[ebx].OwnerSection                              
             mov    edx,[esi].VirtualAddress
             sub    eax,edi                                            ; filebased -> adjust ptr
             sub    edx,[esi].PointerToRawData 
             sub    edi,edx
           .ENDIF
           mov    edx,offset szStrBuffer
           call   _ulonghex
           invoke  SetDlgItemText,[hDlg],IDC_ITBASE,offset szStrBuffer ; show base res address
           mov    esi,[ebx].BaseAddr
           ASSUME ebx : NOTHING
           ASSUME esi: PTR IMAGE_IMPORT_DESCRIPTOR
          .WHILE TRUE
            mov     eax,[esi].NameRva                   
            .BREAK .IF (!eax)
            add     eax,edi                                            ; lpszModuleName 
            mov     [tvinsert].hParent,TVI_ROOT
            mov     [tvinsert].hInsertAfter,TVI_LAST
            mov     [tvinsert].u.item.imask,TVIF_TEXT+TVIF_IMAGE+TVIF_SELECTEDIMAGE
            mov     [tvinsert].u.item.pszText,eax
            mov     [tvinsert].u.item.iImage,16
            mov     [tvinsert].u.item. iSelectedImage,16
            invoke  SendMessage,[hTreeView],TVM_INSERTITEM,0,ADDR tvinsert
            mov     [tvParent],eax
            xor     ebx,ebx                                ; start at index 0
           .WHILE TRUE
             .IF   dword ptr [IsMapped]==TRUE
               mov     eax,[esi].FirstThunk                ; FirstThunk
               add     eax,ebx
               add     eax,edi
               mov     eax,[eax]                           ; (int) *xThunk[index]
               .BREAK .IF (!eax)
               invoke  ExportNameByAddress,eax             ; retrive function name
               .IF eax==0
                 mov eax,offset szNoEntries                ; there isn't any module that exports this address 
               .ENDIF  
             .ELSE
               mov     eax,[esi].OriginalFirstThunk        ; check if there is OriginalFirstThunk
               .IF eax==0
                 mov     eax,[esi].FirstThunk              ; nope -> use FirstThunk
               .ENDIF 
               add     eax,edi                             ; (int) *xThunk[index]
               add     eax,ebx
               mov     eax,[eax]                         
               .BREAK .IF (!eax)
               test    eax,IMAGE_IMPORT_BY_ORDINAL         ; is imported by ordinal? 
               jz      @@2
               and     eax, 0FFFFFFFh                      ; strip off MSB
               mov     edx,offset szOrdinals+6
               call    _ulonghex
               mov     eax,offset szOrdinals
               jmp     @@1
@@2:           lea     eax,[eax+edi+2]                     ; get lpszFunctionName
@@1:         .ENDIF
             mov     [tvinsert].u.item.pszText,eax
             push    [tvParent]  
             pop     [tvinsert].hParent
             mov     [tvinsert].hInsertAfter,TVI_LAST 
             mov     [tvinsert].u.item.imask,TVIF_TEXT+TVIF_IMAGE+TVIF_SELECTEDIMAGE
             mov     [tvinsert].u.item.iImage,17
             mov     [tvinsert].u.item. iSelectedImage,17
             invoke  SendMessage,[hTreeView],TVM_INSERTITEM,0,ADDR tvinsert
             add     ebx,4                                 ; process next IMAGE_THUNK_DATA entry
           .ENDW  
           add     esi,sizeof IMAGE_IMPORT_DESCRIPTOR      ; process next module
          .ENDW  
           ASSUME esi : NOTHING 
           invoke SetForegroundWindow,[hDlg]               ; set focus to our dlg 
           return TRUE
         .ELSEIF [uMsg]==WM_COMMAND
           .IF    [wParam]==IDOK || [wParam]==IDCANCEL
             invoke ImageList_Destroy,[hImageList]         ; dispose imagelist
             invoke EndDialog,hDlg,TRUE
             return TRUE
           .ENDIF
         .ELSE
           return FALSE
         .ENDIF
      ret                     
ImportsDlg ENDP

;----- enum resource hierarchy invoking a callback for each node -----------------------
;  on exit : EAX = 0 = no errors
;  trashed : ASSUME ALL but EBP
EnumResources PROC lpDescriptor: DWORD
        mov     ebp,esp
        push    ebp                                      ; save safe ESP 
        push    offset @@on_r_except                     ; our simple handler
        push    dword ptr fs:[0]                         ; save previous frame 
        mov     fs:[0],esp                               ; establish our SEH frame
        mov     edx,[lpDescriptor]
        mov     ecx,[edx].RESOURCES_DIR_DESCRIPTOR.BaseAddr
        xor     eax,eax
        push    eax
        push    eax
        push    eax  
        push    edx
        push    ecx
        call    EnumResourceDirs
        xor     eax,eax
        jmp   @@enum_exit
@@on_r_except:
        mov     eax,[esp+8]                              ; get ERR structure
        mov     ebp,dword ptr [eax+8]                    ; ERR + 8 = safe ESP 
        stc
        sbb     eax,eax
@@enum_exit:
        pop     dword ptr fs:[0]                         ; remove SEH frame
        mov     esp,ebp       
        pop     ebp
     ret
EnumResources ENDP

;----- enum resource directory invoking a callback for each node -----------------------
;  on entry: ESP+8  = lpResDir; ESP+C  = lpResDesc; ESP+10 = TreeView node
;            ESP+14 = resType ; ESP+18 = level ; 
;  on exit : none
;  trashed : ALL but EBP
EnumResourceDirs:                                           ; no ebp stack frame
lpResDir     TEXTEQU <ESP+08h>                              ; params alias
lpResDesc    TEXTEQU <ESP+0Ch>
tvOwner      TEXTEQU <ESP+10h>
resType      TEXTEQU <ESP+14h>
level        TEXTEQU <ESP+18h>
resCount     TEXTEQU <ESP>                                   ; declare locals 
        sub   esp,4                                          ; and make room
        mov   esi,[lpResDir]
        mov   ebx,[lpResDesc]
        mov   eax,[resType]
        mov   ecx,[level]
        mov   edx,[tvOwner]
        stc                                                  ; mark as resource directory 
        call  ResDispCallback                                ; invoke callback
        mov   [tvOwner],eax                                  ; get TreeView node handle
        ASSUME esi: PTR IMAGE_RESOURCE_DIRECTORY
        movzx ecx,[esi].NumberOfNamedEntries
        add    cx,[esi].NumberOfIdEntries
        mov   [resCount],ecx                                             ; number of entries
        add   dword ptr [lpResDir],sizeof IMAGE_RESOURCE_DIRECTORY       ; skip dir header
        inc   dword ptr [level]
        .REPEAT        
          mov   esi,[lpResDir]
          mov   ebx,[lpResDesc]
          mov   eax,[resType]  
          mov   ecx,[level]
          mov   edx,[tvOwner]
          call  EnumResourceEntry                                          ; inspect node
          add   dword ptr [lpResDir],sizeof IMAGE_RESOURCE_DIRECTORY_ENTRY
          dec   dword ptr [resCount]
        .UNTIL !(dword ptr [resCount])
        add   esp,4                                         ; clear : locals
     ret (5*4)                                              ;         5 params 

;----- enum image_resource_directory_entry invoking a callback for each node -----------
;  on entry: ESI = lpResEntry 
;            EBX = lpResDesc 
;            EAX = resType   
;            ECX = level;     
;            EDX = tvOwner
;  on exit : none
;  trashed : ALL
EnumResourceEntry:
        ASSUME esi: PTR IMAGE_RESOURCE_DIRECTORY_ENTRY
        mov   edi,[esi].OffsetToData
        test  edi,IMAGE_RESOURCE_DATA_IS_DIRECTORY
        jz    @@3
        and   edi,IMAGE_OFFSET_STRIP_HIGH                      ; get offset
        add   edi,[ebx]                                        ; add to ResBase 
        mov   eax,[esi].NameID
        push  ecx                                              ; level 
        push  eax                                              ; resType (level 1)
        push  edx                                              ; tvOwner
        push  ebx                                              ; lpResDesc
        push  edi                                              ; lpResEntry
        call   EnumResourceDirs                                ; inspect directory
        jmp   @@4
@@3:
        add   edi,[ebx]                                        ; add to ResBase 
        clc                                                    ; mark as resource entry
        call  ResDispCallback                                  ; invoke callback
@@4:
      ret       

;----- invoked for each resource hierarchy node ----------------------------------------
;  on entry: ESI = image_resource_directory_entry | image_resource_directory
;            EDI = image_resource_data_entry      | undefinied
;            EBX = lpResDesc                      | lpResDesc
;            EDX = tvOwner                        | tvOwner
;            EAX = resType                        | resType          
;            ECX = level;                         | level
;            CF  = 1 (entry)                      | 0 (directory)
;            global static Image_Base; 
;  on exit : EAX = tvOwner
;  trashed : ASSUME ALL
ResDispCallback:
          jc      @@5
          mov     [tvinsert].hParent,edx
          mov     [tvinsert].u.item.pszText,offset szStrBuffer
          ASSUME edi: PTR IMAGE_RESOURCE_DATA_ENTRY
          invoke   wsprintf,ADDR  szStrBuffer, \
           ADDR  szResEntry, \
           [edi].OffsetToData, \
           [edi].rSize
          invoke  SendMessage,[hTreeView],TVM_INSERTITEM,0,ADDR tvinsert
         ret    
@@5:      .IF ecx==0
            mov     eax,edx
           ret
         .ENDIF  
          mov     [tvinsert].hParent,edx
          mov     [tvinsert].hInsertAfter,TVI_LAST	
          mov     [tvinsert].u.item.imask,TVIF_TEXT+TVIF_IMAGE+TVIF_SELECTEDIMAGE
        .IF ecx==1
          test    eax,IMAGE_RESOURCE_NAME_IS_STRING
          jnz     @@6
          .IF eax > 0 && eax <= 16
            dec   eax
          .ELSE
            mov   eax,16
          .ENDIF 
          mov     [tvinsert].u.item.iImage,eax
          mov     [tvinsert].u.item. iSelectedImage,eax
          mov     edx,offset tResDecode
	  mov     edx,[edx+eax*4]
          mov     [tvinsert].u.item.pszText,edx	  
          invoke  SendMessage,[hTreeView],TVM_INSERTITEM,0,ADDR tvinsert
        .ELSE
@@6:     test    eax,IMAGE_RESOURCE_NAME_IS_STRING
         jz      @@7
         and     eax,IMAGE_OFFSET_STRIP_HIGH                      ; get offset
         add     eax,[ebx]
         lea     edx,[eax+2]
         movzx   eax,word ptr [edx-2]
         mov     ebx,offset szStrBuffer 
         invoke  WideCharToMultiByte,CP_ACP,\
           NULL, \    
           edx, \
           eax,
           ebx , \
           szStrBufferl,\
           NULL, \
           NULL
         mov     byte ptr [ebx+eax],0
         jmp     @@8
@@7:          
           invoke   wsprintf,ADDR  szStrBuffer,ADDR  szResID,eax
@@8:              
           mov     [tvinsert].u.item.pszText,offset szStrBuffer
           invoke  SendMessage,[hTreeView],TVM_INSERTITEM,0,ADDR tvinsert        
        .ENDIF
      ret   


EnumModules PROC lpModRef: DWORD
        LOCAL hSelf    : HANDLE 
        LOCAL mbi      : MEMORY_BASIC_INFORMATION 
        LOCAL hModule  : HANDLE 

        xor edi,edi
        mov esi,[lpModRef]
        ASSUME esi : PTR MODREF
        mov ebx,[hInstance]
        .WHILE ebx < 0c0000000h
          invoke VirtualQuery,ebx,ADDR mbi,sizeof MEMORY_BASIC_INFORMATION 
          mov eax,[mbi].AllocationBase
          .IF [mbi].State==MEM_FREE && [mbi].State==MEM_RESERVE
            mov [mbi].BaseAddress,eax
          .ENDIF
          mov ebx,[mbi].BaseAddress
          .IF ebx!=[hInstDLL] && ebx==eax && ebx!=0
            invoke GetModuleET,ebx
            .IF eax!=-1 && eax!=0
               mov [esi].Exports,eax
               invoke GetModuleFileNameA,ebx,ADDR szStrBuffer,szStrBufferl
               .IF eax !=0
                 mov [esi].BaseAddr,ebx
                 add esi,8
                 invoke strcpy,ADDR szStrBuffer,esi 
                 add esi,MAX_PATH
                 inc edi
              .ENDIF
             .ENDIF  
          .ENDIF  
          mov eax,[mbi].RegionSize
          add ebx,eax
        .ENDW
        mov eax,edi
      ret  
EnumModules ENDP


;----- copy lpszSrc to lpszDest -------------------------------------------------------------
;  on entry: lpszSrc,lpszDest (zero termined)
;  on exit : none
;  trashed : EAX,ECX,EDX
strcpy PROC src: DWORD , dest: DWORD
        mov     ecx,[src]
        mov     edx,[dest]      
        push    edx             
        test    edx,3           
        jz      short @@lcpy
@@algn: mov     al,[ecx]
        inc     ecx
        mov     [edx],al
        inc     edx
        test    al,al
        jz      short @@ret
        test    edx,3
        jnz     short @@algn
@@lcpy: mov     eax,[ecx]
        add     ecx,4
        or      al,al
        jz      short @@one
        or      ah,ah
        jz      short @@two
        test    eax,0ff0000h
        jz      short @@three
        mov     dword ptr [edx],eax
        add     edx,4
        shr     eax,24
        jnz     short @@lcpy
        pop     eax
       ret
@@three:mov     byte ptr [edx+2], 0
@@two:  mov     word ptr [edx], ax
@@ret:  pop     eax             
       ret
@@one:  mov     byte ptr [edx], al
        pop     eax             
       ret
strcpy  ENDP 

;----- convert a DWORD value to Hex ANSI null string ----------------------------------------
;  on entry: EAX = value
;            EDX = lpszBuffer
;  on exit : none
;  trashed : EAX,ECX,EDX
_ulonghex:
        mov   ecx,8
        .WHILE cl!=0
          rol   eax,4
          mov   ch,al
          and   al,0fh
          cmp   al,10
          sbb   al,69h          
          das                     
	  mov   byte ptr [edx],al
          mov   al,ch
          inc   edx
          dec   cl
        .ENDW
        mov   byte ptr [edx],cl
       ret 

PUBLIC GateEntry
PUBLIC ShowResources
PUBLIC ShowImports

End LibMain
			 
